/* houses the main function. */

#include <stdio.h>
#include "bmud.h"
#include "color.h"
#include "config.h"
#include "gui.h"
#include "main.h"
#include "misc.h"
#include "net.h"
#include "tmp.h"	/* should be deleted eventually */

bmud *mud;	/* icky global */

#ifdef USE_GNOME
#include "gnome-compat.h"
#else
#include "gtk-compat.h"
#endif

#include <locale.h>

void bmud_exit()
{
	free_aliases();
	gtk_main_quit();
	return;
}

int main(int argc, char **argv)
{
	bindtextdomain (PACKAGE, LOCALEDIR);
	textdomain (PACKAGE);
	
	mud             = g_malloc( sizeof(bmud) + 1 );
	mud->hist       = g_malloc( sizeof(struct bmud_history) + 1 );
	mud->hist->list = g_malloc( sizeof(gpointer) * (mud->hist->max + 1) );

	init(argc,argv);	/* mud->window is now a window widget */
				/* gnome-compat.h or gtk-compat.h */

	check_my_dir();			/* misc.c */
	
	if(show_conf_dir(""))		/* misc.c */
		gtk_rc_parse( show_conf_dir("gtkrc") );
	
	gtk_widget_realize( mud->window );
	mud->window = spawn_gui();	/* gui.c */

	session_load();			/* prefs.c */

	gtk_widget_set_usize(mud->stat,mud->statsize,20);
	if(mud->statsize==0)
		gtk_widget_set_usize(mud->stat,1,20);
	
	color_load();			/* color.c */

	if(mud->disp_font)g_free(mud->disp_font);
	mud->disp_font = gdk_font_load( mud->disp_font_name );	/* mem leak */

	mud->curr_color = color[7][1];

	gtk_widget_show( mud->window );

		/* why wont' this work with pixmap themes? */
	gdk_window_set_background( GTK_TEXT(mud->text)->text_area, &color[0][0]);
	gdk_window_set_background( GTK_TEXT(mud->stat)->text_area, &color[0][0]);

		/**** this should be deleted eventually ****/
	gtk_text_insert( GTK_TEXT(mud->text) , mud->disp_font, &color[7][1], NULL, STARTUP_MESSAGE, -1);

	gtk_main();
	
	return 0;
}		
